]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- 0.16
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
0a302b4e 25v0.16 (C) 1999-2006 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
47761337 40NOINIT=""
cd445739
AM
41UPDATE=""
42UPDATE5=""
43ADD5=""
44NO5=""
45ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 46CVSROOT=""
cd445739
AM
47
48# It can be used i.e. in log file naming.
49# See LOGFILE example.
50DATE=`date +%Y-%m-%d_%H-%M-%S`
51
52# Example: LOGFILE='../log.$PACKAGE_NAME'
53# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
54# Yes, you can use variable name! Note _single_ quotes!
55LOGFILE=''
56
57LOGDIR=""
58LOGDIROK=""
59LOGDIRFAIL=""
60LASTLOG_FILE=""
61
62CHMOD="no"
63CHMOD_MODE="0444"
64RPMOPTS=""
d1c5a9a7 65RPMBUILDOPTS=""
cd445739
AM
66BCOND=""
67GROUP_BCONDS="no"
947025e5 68CVSIGNORE_DF="no"
d287305c 69
70PATCHES=""
71SOURCES=""
cd445739 72ICONS=""
d287305c 73PACKAGE_RELEASE=""
74PACKAGE_VERSION=""
75PACKAGE_NAME=""
cd445739
AM
76PROTOCOL="ftp"
77WGET_RETRIES=${MAX_WGET_RETRIES:-0}
78CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
79
80CVSTAG=""
81RES_FILE=""
82
83CVS_SERVER="cvs.pld-linux.org"
84DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 85ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 86
36d03934 87DEF_NICE_LEVEL=19
86aafdbe 88SCHEDTOOL="auto"
cd445739
AM
89
90FAIL_IF_NO_SOURCES="yes"
91
18e5347d
ER
92# let get_files skip over files which are present to get those damn files fetched
93SKIP_EXISTING_FILES="no"
94
ab4a2b6e 95if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 96 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 97else
ce40491a 98 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
99fi
100
cd445739
AM
101# Here we load saved user environment used to
102# predefine options set above, or passed to builder
103# in command line.
104# This one reads global system environment settings:
105if [ -f ~/etc/builderrc ]; then
106 . ~/etc/builderrc
107fi
108# And this one cascades settings using user personal
109# builder settings.
110# Example of ~/.builderrc:
111#
112#UPDATE_POLDEK_INDEXES="yes"
113#FETCH_BUILD_REQUIRES="yes"
114#REMOVE_BUILD_REQUIRES="force"
115#GROUP_BCONDS="yes"
116#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 117#TITLECHANGE=no
cd445739 118#
a83e5405 119SU_SUDO=""
cd445739
AM
120if [ -n "$HOME_ETC" ]; then
121 USER_CFG="$HOME_ETC/.builderrc"
122else
123 USER_CFG=~/.builderrc
124fi
125
126[ -f "$USER_CFG" ] && . "$USER_CFG"
127
86aafdbe
ER
128if [ "$SCHEDTOOL" = "auto" ]; then
129 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
130 SCHEDTOOL="schedtool -B -e"
131 else
132 SCHEDTOOL="no"
133 fi
134fi
135
ca2e6c31 136if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
137 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
138 GETURI2="$GETURI"
139 OUTFILEOPT="-O"
ca2e6c31 140elif [ -n "$USE_AXEL" ]; then
cede92b3 141 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
142 GETURI2="$GETURI"
143 OUTFILEOPT="-o"
ca2e6c31 144else
5700ee32
ER
145 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
146 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
147 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 148
7e365483
KK
149 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
150 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
151 OUTFILEOPT="-O"
2bc5451f 152fi
11468b23 153
11468b23
AM
154GETLOCAL="cp -a"
155
156if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
157 RPM="rpm"
158 RPMBUILD="rpm"
159else
160 RPM="rpm"
161 RPMBUILD="rpmbuild"
162fi
163
164POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 165POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 166
cd445739
AM
167run_poldek()
168{
169 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
170 if [ -n "$LOGFILE" ]; then
171 LOG=`eval echo $LOGFILE`
172 if [ -n "$LASTLOG_FILE" ]; then
173 echo "LASTLOG=$LOG" > $LASTLOG_FILE
174 fi
86aafdbe 175 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
176 return $exit_pldk
177 else
86aafdbe 178 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
179 return `cat ${RES_FILE}`
180 rm -rf ${RES_FILE}
181 fi
182}
183
cd445739
AM
184#---------------------------------------------
185# functions
da946cd6 186
5a491465 187usage()
188{
cd445739
AM
189 if [ -n "$DEBUG" ]; then set -xv; fi
190 echo "\
191Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
81f85806 192
cd445739
AM
193[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
194[{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
195[-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
196[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
197[-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
198[-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
199[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 200[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
f19103b5 201[--with/--without <feature>] [--define <macro> <value>] <package>[.spec][:cvstag]
2a5f078d 202
cd445739
AM
203-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
204-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
205-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
206-D, --debug - enable builder script debugging mode,
207-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
208-V, --version - output builder version
209-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
210-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
211 from <package>.spec,
212-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
213 only package from <package>.spec,
c56807e0
ER
214-bp, --build-prep - execute the %prep phase of <package>.spec,
215-bc - reserved (not implemented)
216-bi reserved (not implemented)
cd445739
AM
217-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
218 them into src.rpm,
c56807e0 219--short-circuit - reserved (not implemented)
cd445739
AM
220-B, --branch - add branch
221-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
222 SPECS and \$RPM_BUILD_ROOT),
2a5f078d 223-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
224 - setup \$CVSROOT,
225--define <macro> <value>
226 - define a macro <macro> with value <value>,
227--nodeps - rpm won't check any dependences
228-g, --get - get <package>.spec and all related files from CVS repo
229 or HTTP/FTP,
230-h, --help - this message,
231--http - use http instead of ftp,
232-l <logfile>, --logtofile <logfile>
233 - log all to file,
234-m, --mr-proper - only remove all files related to spec file and all work
235 resources,
236-nc, --no-cvs - don't download sources from CVS, if source URL is given,
237-ncs, --no-cvs-specs
238 - don't check specs in CVS
239-nd, --no-distfiles - don't download from distfiles
240-nm, --no-mirrors - don't download from mirror, if source URL is given,
241-nu, --no-urls - don't try to download from FTP/HTTP location,
242-ns, --no-srcs - don't download Sources
243-ns0, --no-source0 - don't download Source0
244-nn, --no-net - don't download anything from the net
b572253e 245--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
246-ske,
247--skip-existing-files - skip existing files in get_files
cd445739
AM
248--opts <rpm opts> - additional options for rpm
249-q, --quiet - be quiet,
250--date yyyy-mm-dd - build package using resources from specified CVS date,
251-r <cvstag>, --cvstag <cvstag>
252 - build package using resources from specified CVS tag,
253-R, --fetch-build-requires
254 - fetch what is BuildRequired,
255-RB, --remove-build-requires
256 - remove all you fetched with -R or --fetch-build-requires
257 remember, this option requires confirmation,
258-FRB, --force-remove-build-requires
259 - remove all you fetched with -R or --fetch-build-requires
260 remember, this option works without confirmation,
06541433
JR
261-sd, --source-distfiles - list sources available from distfiles (intended for offline
262 operations; does not work when Icon field is present
263 but icon file is absent),
264-sdp, --source-distfiles-paths - list sources available from distfiles -
265 paths relative to distfiles directory (intended for offline
266 operations; does not work when Icon field is present
267 but icon file is absent),
a7eefc54 268-sf, --source-files - list sources - bare filenames (intended for offline
269 operations; does not work when Icon field is present
3621e588 270 but icon file is absent),
a7eefc54 271-sp, --source-paths - list sources - filenames with full local paths (intended for
272 offline operations; does not work when Icon field is present
3621e588 273 but icon file is absent),
2dddf439
ER
274-su, --source-urls - list urls - urls to sources and patches
275 intended for copying urls with spec with lots of macros in urls
cd445739
AM
276-T <cvstag> , --tag <cvstag>
277 - add cvs tag <cvstag> for files,
278-Tvs, --tag-version-stable
094bd95b 279 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 280-Tvn, --tag-version-nest
1691a37b 281 - add cvs tags NEST and NAME-VERSION-RELEASE for files,
cd445739
AM
282-Ts, --tag-stable
283 - add cvs tag STABLE for files,
284-Tn, --tag-nest
285 - add cvs tag NEST for files,
286-Tv, --tag-version
1691a37b 287 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
288-Tp, --tag-prefix <prefix>
289 - add <prefix> to NAME-VERSION-RELEASE tags,
290-tt, --test-tag <prefix>
291 - fail if tag is already present,
50321881
JK
292-ir, --integer-release-only
293 - allow only integer and snapshot releases
cd445739
AM
294-v, --verbose - be verbose,
295-u, --try-upgrade - check version, and try to upgrade package
296-un, --try-upgrade-with-float-version
297 - as above, but allow float version
deccc50e 298-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
299-Upi, --update-poldek-indexes
300 - refresh or make poldek package index files.
c890b916 301-np, --nopatch <patchnumber>
bed98670 302 - don't apply <patchnumber>
dfe2cb9a
MK
303--show-bconds - show available conditional builds, which can be used
304 - with --with and/or --without switches.
cd445739
AM
305--with/--without <feature>
306 - conditional build package depending on %_with_<feature>/
307 %_without_<feature> macro switch. You may now use
308 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
309 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 310--target <platform>, --target=<platform>
3621e588
ER
311 - build for platform <platform>.
312--init-rpm-dir - initialize ~/rpm directory structure
5a491465 313"
314}
315
c890b916 316update_shell_title() {
a0d6396b 317 [ -t 1 ] || return
0b65d15e
ER
318 local len=${COLUMNS:-80}
319 local msg=$(echo "$*" | cut -c-$len)
320
e225de91
ER
321 if [ -n "$BE_VERBOSE" ]; then
322 echo >&2 "$(date +%s.%N) $*"
323 fi
324
982e358c 325 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
326 local pkg
327 if [ -n "$PACKAGE_NAME" ]; then
328 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
329 else
330 pkg=${SPECFILE}
331 fi
332
333 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 334 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
335 case "$TERM" in
336 cygwin|xterm*)
337 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
338 ;;
339 screen*)
340 echo >&2 -ne "\033]0;$msg\007"
341 ;;
342 esac
343 fi
c890b916
ER
344}
345
7e40520f
ER
346# set TARGET from BuildArch: from SPECFILE
347set_spec_target() {
ce40491a
ER
348 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
349 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
350 if [ "$tmp" ]; then
7e40520f
ER
351 TARGET="$tmp"
352 case "$RPMBUILD" in
353 "rpmbuild")
ce40491a 354 TARGET_SWITCH="--target $TARGET" ;;
7e40520f 355 "rpm")
ce40491a 356 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 357 esac
ce40491a
ER
358 fi
359 fi
7e40520f
ER
360}
361
cd445739 362cache_rpm_dump () {
b2aeec7d
AM
363 if [ -n "$DEBUG" ]; then
364 set -x;
365 set -v;
366 fi
7e40520f 367
13974367 368 update_shell_title "cache_rpm_dump"
237bd3f1
ER
369 local rpm_dump
370 rpm_dump=`
d05e8080 371
fa4bf1df 372 # we reset macros not to contain macros.build as all the %() macros are
559d511f 373 # executed here, while none of them are actually needed.
fa4bf1df 374 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
559d511f 375 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
36433112 376 macrofiles="/usr/lib/rpm/macros:$SPECS_DIR/.builder-rpmmacros:~/etc/.rpmmacros:~/.rpmmacros"
237bd3f1 377 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
7cb24972 378 # FIXME: better ideas than .rpmrc?
36433112 379 printf 'include:/usr/lib/rpm/rpmrc\nmacrofiles:%s\n' $macrofiles > .builder-rpmrc
fb198857 380# TODO: move these to /usr/lib/rpm/macros
36433112 381 cat > .builder-rpmmacros <<'EOF'
fb198857
ER
382%requires_releq_kernel_up %{nil}
383%requires_releq_kernel_smp %{nil}
6b8134e3 384%requires_releq() %{nil}
bb01dee9 385%pyrequires_eq() %{nil}
559d511f 386%requires_eq() %{nil}
c13be3d1 387%requires_eq_to() %{nil}
fb198857
ER
388%releq_kernel_up ERROR
389%releq_kernel_smp ERROR
74d9fd14 390%kgcc_package ERROR
237bd3f1 391%_fontsdir ERROR
7141278d 392%ruby_version ERROR
393%ruby_ver_requires_eq() %{nil}
394%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 395%__php_api_requires() %{nil}
7141278d 396%php_major_version ERROR
397%php_api_version ERROR
398%py_ver ERROR
fb198857 399EOF
cd445739 400 case "$RPMBUILD" in
237bd3f1
ER
401 rpm)
402 ARGS='-bp'
403 ;;
404 rpmbuild)
405 ARGS='--nodigest --nosignature --nobuild'
406 ;;
407 esac
3d12d055
JR
408 if [ "$NOINIT" = "yes" ] ; then
409 cat >> .builder-rpmmacros <<'EOF'
410%_specdir ./
411%_sourcedir ./
412EOF
c039643c
JR
413 fi
414 $RPMBUILD --rcfile .builder-rpmrc $ARGS $ARGDIRS --nodeps --define "prep $dump" $BCOND $TARGET_SWITCH $SPECFILE 2>&1
237bd3f1 415 `
fb198857 416 if [ $? -gt 0 ]; then
237bd3f1
ER
417 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
418 echo "$error" >&2
419 Exit_error err_build_fail;
fb198857 420 fi
d05e8080
ER
421
422 # make small dump cache
423 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
424 $2 ~ /^SOURCEURL/ {print}
425 $2 ~ /^PATCHURL/ {print}
426 $2 ~ /^nosource/ {print}
427 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
428 '`
429
13974367 430 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
431}
432
433rpm_dump () {
434 if [ -z "$rpm_dump_cache" ] ; then
435 echo "internal error: cache_rpm_dump not called!" 1>&2
436 fi
437 echo "$rpm_dump_cache"
438}
439
d05e8080
ER
440get_icons()
441{
442 update_shell_title "get icons"
443 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
444 if [ -z "$ICONS" ]; then
445 return
446 fi
447
763f3cbf 448 rpm_dump_cache="kalasaba" NODIST="yes" UPDATE5= get_files $ICONS
d05e8080
ER
449}
450
59398507 451parse_spec()
452{
af4d5315 453 update_shell_title "parsing specfile"
cd445739
AM
454 if [ -n "$DEBUG" ]; then
455 set -x;
456 set -v;
457 fi
b2975fc3 458
d05e8080
ER
459 # icons are needed for successful spec parse
460 get_icons;
461
cd445739 462 cd $SPECS_DIR
cd445739 463 cache_rpm_dump
00fcec7e 464
cd445739
AM
465 if [ "$NOSRCS" != "yes" ]; then
466 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
467 fi
7cb24972 468
cd445739
AM
469 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
470 FAIL_IF_NO_SOURCES="no"
471 fi
472
473 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
474 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
fa4bf1df
ER
475 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3}')
476 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3}')
477 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3}')
78eab2a1 478
cd445739
AM
479 if [ -n "$BE_VERBOSE" ]; then
480 echo "- Sources : `nourl $SOURCES`"
481 if [ -n "$PATCHES" ]; then
482 echo "- Patches : `nourl $PATCHES`"
483 else
484 echo "- Patches : *no patches needed*"
485 fi
486 if [ -n "$ICONS" ]; then
487 echo "- Icon : `nourl $ICONS`"
488 else
489 echo "- Icon : *no package icon*"
490 fi
491 echo "- Name : $PACKAGE_NAME"
492 echo "- Version : $PACKAGE_VERSION"
493 echo "- Release : $PACKAGE_RELEASE"
494 fi
13974367
ER
495
496 update_shell_title "parse_spec: OK!"
cd445739
AM
497}
498
499Exit_error()
500{
501 if [ -n "$DEBUG" ]; then
502 set -x;
503 set -v;
504 fi
505
506 cd "$__PWD"
507
508 case "$1" in
509 "err_no_spec_in_cmdl" )
510 remove_build_requires
511 echo "ERROR: spec file name not specified.";
512 exit 2 ;;
513 "err_no_spec_in_repo" )
514 remove_build_requires
515 echo "Error: spec file not stored in CVS repo.";
516 exit 3 ;;
517 "err_no_source_in_repo" )
518 remove_build_requires
519 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
520 exit 4 ;;
521 "err_build_fail" )
522 remove_build_requires
523 echo "Error: package build failed. (${2:-no more info})";
524 exit 5 ;;
78eab2a1
AM
525 "err_no_package_data" )
526 remove_build_requires
527 echo "Error: couldn't get out package name/version/release from spec file."
528 exit 6 ;;
ce40491a 529 "err_tag_exists" )
50321881
JK
530 remove_build_requires
531 echo "Tag ${2} already exists (spec release: ${3}).";
532 exit 9 ;;
ce40491a 533 "err_fract_rel" )
50321881
JK
534 remove_build_requires
535 echo "Release ${2} not integer and not a snapshot.";
536 exit 10 ;;
fb96e0b5
AM
537 "err_branch_exists" )
538 remove_build_requires
539 echo "Tree branch already exists (${2}).";
540 exit 11 ;;
50321881 541
cd445739 542 esac
50321881 543 echo "Unknown error."
2a5f078d 544 exit 100
cd445739
AM
545}
546
547init_builder()
548{
549 if [ -n "$DEBUG" ]; then
550 set -x;
551 set -v;
0dd6320d 552 fi
cd445739 553
4aeb9973 554 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
555 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
556 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
557 else
558 SOURCE_DIR="."
559 SPECS_DIR="."
560 fi
cd445739
AM
561
562 __PWD="`pwd`"
00fcec7e 563}
564
d6a77ddb 565get_spec()
1471f6d6 566{
c890b916 567
2e5be021 568 update_shell_title "get_spec"
c890b916 569
cd445739
AM
570 if [ -n "$DEBUG" ]; then
571 set -x;
572 set -v;
573 fi
574
575 cd "$SPECS_DIR"
049ab214 576 if [ ! -f "$SPECFILE" ]; then
cd445739
AM
577 SPECFILE="`basename $SPECFILE .spec`.spec";
578 fi
579 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 580
049ab214
ER
581 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
582 echo "Warning: No CVS access defined - using local .spec file"
583 NOCVSSPEC="yes"
cd445739
AM
584 fi
585
049ab214 586 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 587 fi
049ab214 588
cd445739
AM
589 if [ ! -f "$SPECFILE" ]; then
590 Exit_error err_no_spec_in_repo;
591 fi
592
593 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
594 chmod $CHMOD_MODE $SPECFILE
595 fi
596 unset OPTIONS
a7eefc54 597 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 598
ce40491a 599 set_spec_target
cd445739
AM
600}
601
602find_mirror()
603{
604 cd "$SPECS_DIR"
782518da 605 local url="$1"
cd445739
AM
606 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
607 cvs update mirrors >&2
608 fi
609
610 IFS="|"
782518da
ER
611 local origin mirror name rest ol prefix
612 while read origin mirror name rest; do
613 # skip comments and empty lines
614 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
615 continue
616 fi
cd445739
AM
617 ol=`echo -n "$origin"|wc -c`
618 prefix="`echo -n "$url" | head -c $ol`"
619 if [ "$prefix" = "$origin" ] ; then
782518da 620 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
621 echo -n "$mirror$suffix"
622 return 0
623 fi
624 done < mirrors
625 echo "$url"
626}
627
628src_no ()
629{
630 cd $SPECS_DIR
631 rpm_dump | \
632 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
633 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
634 head -n 1 | xargs
1471f6d6 635}
636
cd445739 637src_md5 ()
8ba5cdda 638{
cd445739
AM
639 [ X"$NO5" = X"yes" ] && return
640 no=$(src_no "$1")
641 [ -z "$no" ] && return
642 cd $SPECS_DIR
47a8df12 643 spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
cd445739
AM
644 if [ -z "$spec_rev" ]; then
645 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
646 fi
647 spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
648 md5=$(grep -s -v '^#' additional-md5sums | \
649 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
650 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
651 grep -E '^[0-9a-f]{32}$')
652 if [ X"$md5" = X"" ] ; then
6203ea52
AG
653 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
654 if [ ! -z "$source_md5" ] ; then
7e365483 655 echo $source_md5;
6203ea52 656 else
7e365483
KK
657 # we have empty SourceX-md5, but it is still possible
658 # that we have NoSourceX-md5 AND NoSource: X
659 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
660 if [ ! -z "$nosource_md5" -a ! X"`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" = X"" ] ; then
661 echo $nosource_md5;
662 fi;
6203ea52 663 fi;
cd445739
AM
664 else
665 if [ $(echo "$md5" | wc -l) != 1 ] ; then
666 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
667 fi
668 echo "$md5" | tail -n 1
669 fi
670}
671
06541433
JR
672distfiles_path ()
673{
674 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
675}
676
cd445739
AM
677distfiles_url ()
678{
06541433 679 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
680}
681
682distfiles_attic_url ()
683{
06541433 684 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
685}
686
687good_md5 ()
688{
689 md5=$(src_md5 "$1")
690 [ "$md5" = "" ] || \
691 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
692}
693
a4b50627
AF
694good_size ()
695{
ce40491a
ER
696 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
697 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
698}
699
947025e5 700cvsignore_df ()
701{
702 if [ "$CVSIGNORE_DF" != "yes" ]; then
703 return
704 fi
705 cvsignore=${SOURCE_DIR}/.cvsignore
706 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
707 echo "$1" >> $cvsignore
708 fi
709}
710
e7fa3b9f
ER
711cvsup()
712{
ce40491a
ER
713 update_shell_title "cvsup"
714 local OPTIONS="up "
715 if [ -n "$CVSROOT" ]; then
716 OPTIONS="-d $CVSROOT $OPTIONS"
717 fi
b1c6aace 718
ce40491a
ER
719 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
720 OPTIONS="$OPTIONS -A"
721 else
722 if [ -n "$CVSDATE" ]; then
723 OPTIONS="$OPTIONS -D $CVSDATE"
724 fi
725 if [ -n "$CVSTAG" ]; then
726 OPTIONS="$OPTIONS -r $CVSTAG"
727 fi
728 fi
e7fa3b9f 729
ce40491a
ER
730 local result=1
731 local retries_counter=0
732 if [ $# = 1 ]; then
733 update_shell_title "cvsup: $*"
734 else
735 update_shell_title "cvsup: $# files"
736 fi
737 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
738 retries_counter=$(( $retries_counter + 1 ))
739 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
740 result=$?
741 [ -n "$output" ] && echo "$output"
742 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
743 echo "Trying again [$*]... ($retries_counter)"
744 update_shell_title "cvsup: retry #$retries_counter"
745 sleep 2
746 continue
747 else
748 break
749 fi
750 done
751 update_shell_title "cvsup: done!"
752 return $result
e7fa3b9f
ER
753}
754
cd445739
AM
755get_files()
756{
7cb24972 757 update_shell_title "get_files"
cd445739
AM
758
759 if [ -n "$DEBUG" ]; then
760 set -x;
761 set -v;
762 fi
763
f09c0772 764 if [ $# -gt 0 ]; then
cd445739
AM
765 cd "$SOURCE_DIR"
766
b1c6aace 767 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 768 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
769 NOCVS="yes"
770 fi
771
f2e42a41 772 local nc=0
e7fa3b9f 773 local get_files_cvs=""
3815b69a 774 for i in "$@"; do
f2e42a41 775 nc=$((nc + 1))
dcebdffb 776 local cvsup=0
3815b69a 777 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 778 update_shell_title "$i"
f09c0772
ER
779 local fp=`nourl "$i"`
780 if [ -f "$fp" ] && [ "$SKIP_EXISTING_FILES" = "yes" ]; then
ce40491a 781 continue
18e5347d 782 fi
cd445739
AM
783 if [ -n "$UPDATE5" ]; then
784 if [ -n "$ADD5" ]; then
f09c0772 785 [ "$fp" = "$i" ] && continue
cd445739
AM
786 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
787 else
788 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
789 fi
790 fi
791 FROM_DISTFILES=0
f09c0772 792 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
793 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
794 echo "Warning: no URL given for $i"
795 fi
796
d05e8080 797 if [ -z "$NODIST" ] && [ -n "$(src_md5 "$i")" ]; then
a4b50627 798 if good_md5 "$i" && good_size "$i"; then
deccc50e 799 echo "$(nourl "$i") having proper md5sum already exists"
cd445739
AM
800 continue
801 fi
4ea1c265 802 target="$fp"
cd445739
AM
803 url=$(distfiles_url "$i")
804 url_attic=$(distfiles_attic_url "$i")
805 FROM_DISTFILES=1
33da77c4 806 if [ "`echo $url | grep -E '^(\.|/)'`" ]; then
18a52930 807 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
808 ${GETLOCAL} $url $target
809 else
810 if [ -z "$NOMIRRORS" ]; then
811 url="`find_mirror "$url"`"
812 fi
18a52930 813 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 814 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 815 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 816 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 817 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
818 fi
819 fi
820 if ! test -s "$target"; then
821 rm -f "$target"
822 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 823 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
824 ${GETLOCAL} $url_attic $target
825 else
826 if [ -z "$NOMIRRORS" ]; then
827 url_attic="`find_mirror "$url_attic"`"
828 fi
18a52930 829 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 830 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 831 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 832 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 833 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
834 fi
835 fi
836 fi
947025e5 837 if test -s "$target"; then
838 cvsignore_df $target
839 else
cd445739
AM
840 rm -f "$target"
841 FROM_DISTFILES=0
842 fi
d05e8080
ER
843 elif [ "$NOCVS" != "yes" -a -z "$(src_md5 "$i")" ]; then
844 if [ $# -gt 1 ]; then
845 get_files_cvs="$get_files_cvs $fp"
846 update_shell_title "$fp (will cvs up later)"
847 cvsup=1
848 else
849 cvsup $fp
850 fi
cd445739
AM
851 fi
852
f09c0772 853 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
854 if [ -z "$NOMIRRORS" ]; then
855 im="`find_mirror "$i"`"
856 else
857 im="$i"
858 fi
ce40491a 859 update_shell_title "${GETURI%% *}: $im"
cd445739 860 ${GETURI} "$im" || \
33da77c4 861 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 862 update_shell_title "${GETURI2%% *}: $im"
cd445739 863 ${GETURI2} "$im"
7e365483 864 fi
cd445739
AM
865 fi
866
dcebdffb
ER
867 if [ "$cvsup" = 1 ]; then
868 continue
869 fi
870
cd445739
AM
871 fi
872 srcno=$(src_no $i)
f09c0772 873 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
cd445739
AM
874 Exit_error err_no_source_in_repo $i;
875 elif [ -n "$UPDATE5" ] && \
876 ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
877 [ -z "$(grep -E -i '^NoSource[ ]*:[ ]*'$i'([ ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
878 grep -q -i -E '^#[ ]*source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
879 then
deccc50e 880 echo "Updating source-$srcno md5."
f09c0772 881 md5=$(md5sum "$fp" | cut -f1 -d' ')
cd445739 882 perl -i -ne '
deccc50e
AM
883 print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
884 print "# Source'$srcno'-md5:\t'$md5'\n"
cd445739
AM
885 if /^Source'$srcno'\s*:\s+/;
886 ' \
887 $SPECS_DIR/$SPECFILE
888 fi
2a5f078d 889
a4b50627 890 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
891 :
892 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 893 # wrong md5 from distfiles: remove the file and try again
cd445739 894 # but only once ...
deccc50e 895 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
896 FROM_DISTFILES=2
897 rm -f $target
18a52930 898 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 899 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 900 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 901 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 902 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
903 fi
904 if ! test -s "$target"; then
905 rm -f "$target"
18a52930 906 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 907 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 908 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 909 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 910 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
911 fi
912 fi
913 test -s "$target" || rm -f "$target"
914 fi
915
a4b50627 916 if good_md5 "$i" && good_size "$i" ; then
cd445739
AM
917 :
918 else
deccc50e
AM
919 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
920 echo "or -5 to update md5 sums, if you're sure files are correct."
cd445739
AM
921 Exit_error err_no_source_in_repo $i
922 fi
923 done
e7fa3b9f
ER
924 SHELL_TITLE_PREFIX=""
925
926 if [ "$get_files_cvs" ]; then
ce40491a 927 cvsup $get_files_cvs
e7fa3b9f 928 fi
cd445739
AM
929
930 if [ "$CHMOD" = "yes" ]; then
3815b69a 931 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
932 if [ -n "$CHMOD_FILES" ]; then
933 chmod $CHMOD_MODE $CHMOD_FILES
934 fi
935 fi
cd445739
AM
936 fi
937}
938
939make_tagver() {
ce40491a
ER
940 if [ -n "$DEBUG" ]; then
941 set -x;
942 set -v;
943 fi
78eab2a1 944
ce40491a
ER
945 # Check whether first character of PACKAGE_NAME is legal for tag name
946 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
947 TAG_PREFIX=tag_
948 fi
949 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
950 # Remove #kernel.version_release from TAGVER because tagging sources
951 # could occur with different kernel-headers than kernel-headers used at build time.
952 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
953 echo -n "$TAGVER"
cd445739
AM
954}
955
956tag_files()
957{
958 TAG_FILES="$@"
959
960 if [ -n "$DEBUG" ]; then
961 set -x;
962 set -v;
963 fi
964
965 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
966 echo "Version: $PACKAGE_VERSION"
967 echo "Release: $PACKAGE_RELEASE"
968
969 TAGVER=`make_tagver`
970
971 if [ "$TAG_VERSION" = "yes" ]; then
972 echo "CVS tag: $TAGVER"
973 fi
974 if [ -n "$TAG" ]; then
975 echo "CVS tag: $TAG"
976 fi
977
978 OPTIONS="tag -F"
979 if [ -n "$CVSROOT" ]; then
980 OPTIONS="-d $CVSROOT $OPTIONS"
981 fi
982
983 cd "$SOURCE_DIR"
984 for i in $TAG_FILES
985 do
986 # don't tag files stored on distfiles
987 [ -n "`src_md5 $i`" ] && continue
988 if [ -f "`nourl $i`" ]; then
989 if [ "$TAG_VERSION" = "yes" ]; then
990 cvs $OPTIONS $TAGVER `nourl $i`
991 fi
992 if [ -n "$TAG" ]; then
993 cvs $OPTIONS $TAG `nourl $i`
994 fi
995 else
996 Exit_error err_no_source_in_repo $i
997 fi
998 done
999
1000 cd "$SPECS_DIR"
1001 if [ "$TAG_VERSION" = "yes" ]; then
1002 cvs $OPTIONS $TAGVER $SPECFILE
1003 fi
1004 if [ -n "$TAG" ]; then
1005 cvs $OPTIONS $TAG $SPECFILE
1006 fi
1007
1008 unset OPTIONS
1009 fi
1010}
1011
1012branch_files()
1013{
1014 TAG=$1
1015 echo "CVS branch tag: $TAG"
1016 shift;
1017
1018 TAG_FILES="$@"
1019
1020 if [ -n "$DEBUG" ]; then
1021 set -x;
1022 set -v;
1023 fi
1024
1025 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
1026
1027 OPTIONS="tag -b"
1028 if [ -n "$CVSROOT" ]; then
1029 OPTIONS="-d $CVSROOT $OPTIONS"
1030 fi
1031 cd "$SOURCE_DIR"
1032 for i in $TAG_FILES
1033 do
1034 if [ -f `nourl $i` ]; then
1035 cvs $OPTIONS $TAG `nourl $i`
1036 else
1037 Exit_error err_no_source_in_repo $i
1038 fi
1039 done
1040 cd "$SPECS_DIR"
1041 cvs $OPTIONS $TAG $SPECFILE
1042
1043 unset OPTIONS
1044 fi
1045}
1046
1047
1048
59398507 1049build_package()
1050{
2e5be021 1051 update_shell_title "build_package"
cd445739
AM
1052 if [ -n "$DEBUG" ]; then
1053 set -x;
1054 set -v;
1055 fi
5a491465 1056
cd445739
AM
1057 cd "$SPECS_DIR"
1058
1059 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1060 update_shell_title "build_package: try_upgrade"
cd445739 1061 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1062 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1063 else
cc538c24 1064 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1065 fi
1066
1067 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1068
1069 if [ -n "$TNEWVER" ]; then
1070 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1071 echo "New version found, updating spec file to version " $TNEWVER
1072 cp -f $SPECFILE $SPECFILE.bak
1073 chmod +w $SPECFILE
1074 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1075 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
cd445739 1076 parse_spec;
4ea1c265 1077 NODIST="yes" UPDATE5="yes" get_files $SOURCES $PATCHES;
cd445739
AM
1078 unset TOLDVER TNEWVER TNOTIFY
1079 fi
1080 fi
1081 cd "$SPECS_DIR"
2a5f078d 1082
cd445739
AM
1083 case "$COMMAND" in
1084 build )
1085 BUILD_SWITCH="-ba" ;;
1086 build-binary )
1087 BUILD_SWITCH="-bb" ;;
1088 build-source )
1089 BUILD_SWITCH="-bs --nodeps" ;;
1090 build-prep )
1091 BUILD_SWITCH="-bp --nodeps" ;;
1092 esac
c890b916 1093
2e5be021 1094 update_shell_title "build_package: $COMMAND"
cd445739
AM
1095 if [ -n "$LOGFILE" ]; then
1096 LOG=`eval echo $LOGFILE`
1097 if [ -d "$LOG" ]; then
1098 echo "Log file $LOG is a directory."
1099 echo "Parse error in the spec?"
1100 Exit_error err_build_fail;
1101 fi
1102 if [ -n "$LASTLOG_FILE" ]; then
1103 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1104 fi
1105 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1106 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1107 RETVAL=`cat $RES_FILE`
1108 rm $RES_FILE
1109 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1110 if [ "$RETVAL" -eq "0" ]; then
1111 mv $LOG $LOGDIROK
1112 else
1113 mv $LOG $LOGDIRFAIL
1114 fi
1115 fi
8ba5cdda 1116 else
86aafdbe 1117 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1118 RETVAL=$?
8ba5cdda 1119 fi
cd445739
AM
1120 if [ "$RETVAL" -ne "0" ]; then
1121 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1122 echo "\n!!! Package with new version cannot be built automagically\n"
cd445739
AM
1123 mv -f $SPECFILE.bak $SPECFILE
1124 fi
1125 Exit_error err_build_fail;
1126 fi
1127 unset BUILD_SWITCH
1128}
1129
1130nourl()
1131{
1132 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1133}
1134
cd445739
AM
1135install_required_packages()
1136{
1137 run_poldek -vi $1
1138 return $?
1139}
1140
fa4bf1df
ER
1141find_spec_bcond() {
1142 # taken from find-spec-bcond, but with just getting the list
1143 local SPEC="$1"
1144 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1145 awk -F"\n" '
1146 /^%changelog/ { exit }
1147 /_with(out)?_[_a-zA-Z0-9]+/{
1148 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1149 print substr($0, RSTART, RLENGTH);
1150 }
1151 /^%bcond_with/{
1152 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1153 bcond = substr($0, RSTART +5 , RLENGTH -5);
1154 gsub(/[ \t]+/,"_",bcond);
1155 print bcond
1156 }' $SPEC | LC_ALL=C sort -u
1157}
1158
cd445739
AM
1159set_bconds_values()
1160{
0b65d15e 1161 update_shell_title "set bcond values"
c890b916 1162
cd445739
AM
1163 AVAIL_BCONDS_WITHOUT=""
1164 AVAIL_BCONDS_WITH=""
1165 if `grep -q ^%bcond ${SPECFILE}`; then
1166 BCOND_VERSION="NEW"
36d03934 1167 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1168 BCOND_VERSION="OLD"
1169 else
fa4bf1df 1170 return
cd445739 1171 fi
301cbfd4 1172
fa4bf1df
ER
1173 local bcond_avail=$(find_spec_bcond $SPECFILE)
1174
301cbfd4
ER
1175 # expand bconds from ~/.bcondrc
1176 # The file structure is like gentoo's package.use:
1177 # ---
1178 # * -selinux
1179 # samba -mysql -pgsql
47a8df12 1180 # w32codec-installer license_agreement
301cbfd4
ER
1181 # php +mysqli
1182 # ---
fa4bf1df 1183 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
3e1cbfe0 1184 SN=${SPECFILE%%\.spec}
301cbfd4 1185
fa4bf1df
ER
1186 local bcondrc=$HOME/.bcondrc
1187 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
c8a3e2ac 1188
301cbfd4
ER
1189 while read pkg flags; do
1190 # ignore comments
1191 [[ "$pkg" == \#* ]] && continue
1192
1193 # any package or current package?
fa4bf1df 1194 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
301cbfd4 1195 for flag in $flags; do
fa4bf1df 1196 local opt=${flag#[+-]}
301cbfd4
ER
1197
1198 # use only flags which are in this package.
fa4bf1df 1199 if [[ $bcond_avail = *${opt}* ]]; then
3b5101f0
ER
1200 if [[ $flag = -* ]]; then
1201 BCOND="$BCOND --without $opt"
301cbfd4 1202 else
3b5101f0 1203 BCOND="$BCOND --with $opt"
301cbfd4
ER
1204 fi
1205 fi
1206 done
1207 fi
fa4bf1df
ER
1208 done < $bcondrc
1209 update_shell_title "parse ~/.bcondrc: DONE!"
301cbfd4
ER
1210 fi
1211
fa4bf1df 1212 update_shell_title "parse bconds"
cd445739 1213 case "${BCOND_VERSION}" in
fa4bf1df 1214 NONE)
7e365483 1215 :
cd445739 1216 ;;
7e365483 1217 OLD)
cd445739 1218 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1219 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1220 do
fa4bf1df
ER
1221 AVAIL_BCOND_WITHOUT=${opt#_without_}
1222 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1223 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1224 else
1225 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1226 fi
1227 done
2a5f078d 1228
fa4bf1df 1229 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1230 do
fa4bf1df
ER
1231 AVAIL_BCOND_WITH=${opt#_with_}
1232 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1233 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1234 else
1235 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1236 fi
1237 done
1238 ;;
1239 NEW)
fa4bf1df
ER
1240 local cond_type="" # with || without
1241 for opt in $bcond_avail; do
cd445739
AM
1242 case "$opt" in
1243 _without)
1244 cond_type="without"
1245 ;;
1246 _with)
1247 cond_type="with"
1248 ;;
f8d24cee 1249 _without_*)
fa4bf1df
ER
1250 AVAIL_BCOND_WITHOUT=${opt#_without_}
1251 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1252 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1253 else
1254 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1255 fi
1256 ;;
1257 _with_*)
fa4bf1df
ER
1258 AVAIL_BCOND_WITH=${opt#_with_}
1259 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1260 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1261 else
1262 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1263 fi
1264 ;;
cd445739
AM
1265 *)
1266 case "$cond_type" in
1267 with)
1268 cond_type=''
1269 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1270 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1271 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1272 else
1273 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1274 fi
7e365483 1275 ;;
cd445739
AM
1276 without)
1277 cond_type=''
1278 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1279 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1280 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1281 else
1282 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1283 fi
1284 ;;
1285 esac
1286 ;;
1287 esac
1288 done
1289 ;;
1290 esac
1291}
1292
1293run_sub_builder()
1294{
1295 package_name="${1}"
af6b168f 1296 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1297 #
1298